#ifndef __ID3_TAGS_H__
#define __ID3_TAGS_H__

#include <stdio.h>

#include "AudioInfo.h"
#include "ID3Tag.h"

class ID3Tags : public AudioInfo
{
	public:
		ID3Tags(const char* filename);
		virtual ~ID3Tags();

		virtual bool HasID3Tags();
		virtual int CreateID3Tags();

		virtual const char* Artist();
		virtual const char* Album();
		virtual const char* Title();
		virtual const char* Year();
		virtual const char* Comment();
		virtual const char* Track();
		virtual const char* Genre();

		virtual void SetArtist(const char* value);
		virtual void SetAlbum(const char* value);
		virtual void SetTitle(const char* value);
		virtual void SetYear(const char* value);
		virtual void SetComment(const char* value);
		virtual void SetTrack(const char* value);
		virtual void SetGenre(const char* value);

		virtual int ReadArtist();
		virtual int ReadAlbum();
		virtual int ReadTitle();
		virtual int ReadYear();
		virtual int ReadComment();
		virtual int ReadTrack();
		virtual int ReadGenre();

		virtual int Write();
		virtual int WriteArtist();
		virtual int WriteAlbum();
		virtual int WriteTitle();
		virtual int WriteYear();
		virtual int WriteComment();
		virtual int WriteTrack();
		virtual int WriteGenre();

	protected:
		FILE* file;
		ID3Tag* tag;
		ID3Tag* artist;
		ID3Tag* album;
		ID3Tag* title;
		ID3Tag* year;
		ID3Tag* comment;
		ID3Tag* blank;
		ID3Tag* track;
		ID3Tag* genre;

	private:
		char* trackValue;
};

#endif

