#include <be/app/Application.h>
#include <be/app/Message.h>
#include <be/interface/Alert.h>
#include <be/support/Debug.h>
#include "AppDefs.h"
#include "Application.h"
#include "AppWindow.h"
#include "CreateOggMimetype.h"
#include "GUIStrings.h"
#include "Preferences.h"

Application::Application() : BApplication(SIGNATURE)
{
	PRINT(("Application::Application()\n"));
	CreateOggMimetype();
	Preferences::CreatePrefs();
	window = AppWindow::CreateWindow();
	window->Show();
}

void
Application::ArgvReceived(int32 argc, char** argv)
{
	PRINT(("Application::ArgvReceived(int32,char**)\n"));
}

void
Application::RefsReceived(BMessage* message)
{
	PRINT(("Application::RefsReceived(BMessage*)\n"));

	window->PostMessage(message);
}

void
main()
{
	PRINT(("main()\n"));

	new Application();
	be_app->Run();
	delete be_app;
}
