#ifndef __EDITOR_VIEW_H__
#define __EDITOR_VIEW_H__

#include "AddOnView.h"

class BCheckBox;
class BList;
class BMenuField;
class BMessage;
class BRadioButton;
class BRect;
class BTextControl;

class EditorView : public AddOnView
{
	public:
		EditorView(BRect frame);
		~EditorView();
		virtual void AttachedToWindow();
		virtual void GetPreferredSize(float* width, float* height);
		virtual void Hide();
		virtual void Show();
		virtual void SelectionChanged(BList* list);
		virtual void Apply();
		virtual void Reset();
		virtual void MessageReceived(BMessage* message);
	private:
		void InitView();
		void GenreSelectionAction();
		static int32 ApplyFunction(void* args);
		void SetEnabled(BCheckBox* checkbox, BControl* control);
		void SetEnabled(BCheckBox* checkbox, BMenuField* menufield);
		void WidgetsSetValues();
		void WidgetsSetEnabled();
		void WidgetsRBValues();
		BRadioButton* tagRadioButton;
		BRadioButton* attributeRadioButton;
		BCheckBox* applyCheckBox;
		BCheckBox* artistCheckBox;
		BCheckBox* albumCheckBox;
		BCheckBox* titleCheckBox;
		BCheckBox* yearCheckBox;
		BCheckBox* commentCheckBox;
		BCheckBox* trackCheckBox;
		BCheckBox* genreCheckBox;
#ifdef _TTE_
		BCheckBox* ratingCheckBox;
		BCheckBox* tempoCheckBox;
		BCheckBox* composerCheckBox;
#endif
		BTextControl* artistTextControl;
		BTextControl* albumTextControl;
		BTextControl* titleTextControl;
		BTextControl* yearTextControl;
		BTextControl* commentTextControl;
		BTextControl* trackTextControl;
		BTextControl* genreTextControl;
		BMenuField* genreMenuField;
#ifdef _TTE_
		BTextControl* ratingTextControl;
		BTextControl* tempoTextControl;
		BTextControl* composerTextControl;
#endif
		BBox* editBox;
		BBox* genreBox;
};

#endif
