#ifndef __NA_VIEW_H__
#define __NA_VIEW_H__

#include "AddOnView.h"

class BBox;
class BList;
class BMessage;
class BRadioButton;
class BRect;
class BStringView;
class BTextControl;

class NAView : public AddOnView
{
	public:
		NAView(BRect frame);
		~NAView();
		virtual void AttachedToWindow();
		virtual void GetPreferredSize(float* width, float* height);
		virtual void Hide();
		virtual void Show();
		virtual void SelectionChanged(BList* list);
		virtual void Apply();
		virtual void Reset();
		virtual void MessageReceived(BMessage* message);
	private:
		void InitView();
		static int32 ApplyFunction(void* args);
		void WidgetsSetValues();
		void WidgetsSetEnabled();
		void WidgetsRBValues();
		BRadioButton* a2nRadioButton;
		BRadioButton* n2aRadioButton;
		BStringView* artistStringView;
		BStringView* albumStringView;
		BStringView* titleStringView;
		BStringView* yearStringView;
		BStringView* commentStringView;
		BStringView* trackStringView;
		BStringView* genreStringView;
		BStringView* wildcardStringView;
		BTextControl* patternTextControl;
		BBox* directionBox;
};

#endif
