#include <be/app/Message.h>
#include <be/support/Debug.h>
#include "Application.h"
#include "AppView.h"
#include "EditorView.h"
#include "PLView.h"
#include "Preferences.h"
#include "NAView.h"
#include "TAView.h"

PLView::PLView(BRect frame) : PickListView(frame,"pickListView",
		B_FOLLOW_LEFT | B_FOLLOW_TOP)
{
	PRINT(("PLView::PLView(BRect)\n"));
}

void
PLView::AttachedToWindow()
{
	PickListView::AttachedToWindow();

	PRINT(("PLView::AttachedToWindow()\n"));
	
	BRect frame = BoxBounds();
	AddView(new EditorView(frame));
	AddView(new TAView(frame));
	//AddView(new NAView(frame));

	if(prefs->Lock())
	{
		SelectView(prefs->GetPrefFunction());
		prefs->Unlock();
	}
}
