#ifndef __PREFERENCES_H__
#define __PREFERENCES_H__

#include <be/interface/Window.h>
#include <be/support/String.h>

class BButton;
class BMenuField;
class BMessage;
class BRect;
class BString;
class BTextControl;

class Preferences : public BWindow
{
	public:
		Preferences();
		Preferences(BMessage* archive);
		~Preferences();
		virtual status_t Archive(BMessage* archive,bool deep=true) const;

		int32 GetPrefFunction() const;
		const char* GetPrefNAPattern() const;

		virtual void MessageReceived(BMessage* message);
		static void CreatePrefs();
	private:
		void InitWindow();
		void ResetWidgets();
		void ApplyAction();
		void CancelAction();
		void SaveWindow();
		int32 prefFunction;
		BString prefNAPattern;
		BMenuField* prefFunctionMenuField;
		BTextControl* prefNAPatternTextControl;
		BButton* applyButton;
		BButton* cancelButton;
};

extern Preferences* prefs;

#endif
