#ifndef _AUDIO_ATTRIBUTES_H__
#define _AUDIO_ATTRIBUTES_H__

#include "AudioInfo.h"

class BFile;
class AudioAttribute;

class AudioAttributes : public AudioInfo
{
	public:
		AudioAttributes(BFile* file);
		virtual ~AudioAttributes();

		virtual const char* Artist();
		virtual const char* Album();
		virtual const char* Title();
		virtual const char* Year();
		virtual const char* Comment();
		virtual const char* Track();
#ifdef _TTE_
		virtual const char* Rating();
		virtual const char* Tempo();
		virtual const char* Composer();
#endif
		virtual const char* Genre();

		virtual void SetArtist(const char* value);
		virtual void SetAlbum(const char* value);
		virtual void SetTitle(const char* value);
		virtual void SetYear(const char* value);
		virtual void SetComment(const char* value);
		virtual void SetTrack(const char* value);
#ifdef _TTE_
		virtual void SetRating(const char* value);
		virtual void SetTempo(const char* value);
		virtual void SetComposer(const char* value);
#endif
		virtual void SetGenre(const char* value);

		virtual int Read();
		virtual int ReadArtist();
		virtual int ReadAlbum();
		virtual int ReadTitle();
		virtual int ReadYear();
		virtual int ReadComment();
		virtual int ReadTrack();
#ifdef _TTE_
		virtual int ReadRating();
		virtual int ReadTempo();
		virtual int ReadComposer();
#endif
		virtual int ReadGenre();

		virtual int Write();
		virtual int WriteArtist();
		virtual int WriteAlbum();
		virtual int WriteTitle();
		virtual int WriteYear();
		virtual int WriteComment();
		virtual int WriteTrack();
#ifdef _TTE_
		virtual int WriteRating();
		virtual int WriteTempo();
		virtual int WriteComposer();
#endif
		virtual int WriteGenre();

	protected:
		int InitAttribute(AudioAttribute* attrib);

		BFile* file;
		AudioAttribute* tag;
		AudioAttribute* artist;
		AudioAttribute* album;
		AudioAttribute* title;
		AudioAttribute* year;
		AudioAttribute* comment;
		AudioAttribute* blank;
		AudioAttribute* track;
#ifdef _TTE_
		AudioAttribute* rating;
		AudioAttribute* tempo;
		AudioAttribute* composer;
#endif
		AudioAttribute* genre;
};

#endif

